<?php

/*********************************************************************

 freo | 保護データ取得 | アルバムレスポンス (2015/09/09)

 freo.jp
 customize by 32877(http://32877.xii.jp)

*********************************************************************/

/* 保護データ取得 */
function freo_security_plugin_albumres($mode, $plugin_albumreses, $exceptions = array())
{
	global $freo;

	if (empty($plugin_albumreses)) {
		return array();
	}

	//データ初期化
	$securities = array();
	foreach ($plugin_albumreses as $plugin_albumres) {
		$securities[$plugin_albumres] = false;
	}

	$plugin_albumreses  = array_map('intval', $plugin_albumreses);
	$protects = array();

	//保護データID取得
	if ($mode == 'nobody' or ($freo->user['authority'] != 'root' and $freo->user['authority'] != 'author')) {
		//制限方法を取得
		$stmt = $freo->pdo->query('SELECT id, restriction FROM ' . FREO_DATABASE_PREFIX . 'plugin_albumreses WHERE id IN(' . implode(',', $plugin_albumreses) . ') AND restriction IS NOT NULL');
		if (!$stmt) {
			freo_error($freo->pdo->errorInfo());
		}

		$restricts = array();
		while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
			if (!in_array('user', $exceptions) and $data['restriction'] == 'user') {
				$restricts['users'][] = $data['id'];
			} elseif (!in_array('root', $exceptions) and $data['restriction'] == 'root') {
				$restricts['root'][] = $data['id'];
			}
		}

		//管理者のみに制限
		if (!empty($restricts['root']) and ($mode == 'nobody' or $freo->user['authority'] != 'root')) {
			$protects = array_merge($protects, $restricts['root']);
		}

		//ユーザー登録で制限
		if (!empty($restricts['users']) and ($mode == 'nobody' or !$freo->user['id'])) {
			$protects = array_merge($protects, $restricts['users']);
		}

		//保護データ情報設定
		foreach ($protects as $protect) {
			$securities[$protect] = true;
		}
	}

	return $securities;
}

?>
